﻿package com.identityMine.documentClass
{
 import flash.display.MovieClip;
 import flash.geom.Rectangle;
 import flash.geom.Point;
 import flash.geom.ColorTransform;
 
  import flash.events.MouseEvent; // Mouse responses
 
 import flash.display.BitmapData;
 import flash.utils.*; // SetInterval
 import caurina.transitions.Tweener; // Tween class
	
 import com.identityMine.manager.MANAGER;
 
 // This is to allow us to read in our input file
 //import com.identityMine.filereader.FILEREADER;	
 
 import DNA; 
 import SURFACE;
 
  
 public class DocumentClass extends MovieClip
 {
  // Points for non-bounding box 4 sided structure
  var TopLeftPoint : Point, BottomLeftPoint : Point, TopRightPoint : Point, BottomRightPoint : Point;
  
  private var HEX:Boolean = false;
  private var debug:Boolean = false;
  private var _DNA:DNA
  private var _surface:SURFACE;
  
  private var _DNAManager : MANAGER;
  private var MovementSequence : Array;

  //private var _filereader : FILEREADER = new FILEREADER(); 
  // These are used for updating where the _spider currently is
  // These should probably be private variables within the spider class,
  // which are updated by a method.
  //
  // An even better approach would be to actually update the position of the _spider, 
  // but I'm not sure how to do that with a tween.
  private var transitionX = 0 ;
  private var transitionY = 0 ;
  private var Delay = 0;
  var DNA_array :Array;
  
  var ROWS = 5;
  var COLUMNS = 5;
  var ROW_SPACE = 39;
  var COL_SPACE = 30;  
  var plane_incline = 0;
  var offset = 20;

  var _spider : SPIDER;
  
  
  // Mouse click state
  private var clicked : Boolean; // To determine if we have clicked our movie
  private var OldClickX;
  private var OldClickY;
  
  
  public function DocumentClass()
  {	 
	  //DNA_array = new Array(ROWS * COLUMNS);
	   DNA_array = new Array;
	  //this.height = 600;
	  //this.width = 1000;
	  
	  // This is a test of a movement sequence to get the spider moving
	  MovementSequence = [[1,1],[1,2],[2,2],[2,3], [3,3], [3,4], [2,4], [1,4], [1,3], [1,2]];
	 // MovementSequence = [[1,1],[1,2]];
	  
	  
	 //var MovementSequence = [[1,1]];
	  // This would be nice to put inside the constructor, but ActionScript is not allowing 
	  // me to do that...
	
	 
	
	  _spider = new SPIDER();
	  _spider.x = 155;
	  _spider.transitionX = _spider.x;
	  _spider.y = 90;
	  _spider.transitionY = _spider.y;
	  
	  _spider.scaleX = .25;
	  _spider.scaleY = .25;
	  
	 // Let's generate the surface first
	  GenerateSurface(ROWS, COLUMNS, ROW_SPACE, COL_SPACE, 360-plane_incline);
	  
	  //GenerateSquare(xNum, xspace, yNum, ySpace, plane_incline, plane_rotation)
      GenerateSquare(ROWS, ROW_SPACE, COLUMNS, COL_SPACE, plane_incline, -7);
	
	 // GenerateRandom(20, plane_incline);
	 
	 // public function GenerateHex(xNum, xspace, yNum, ySpace, offset, plane_incline, plane_rotation)
	 // GenerateHex(ROWS, ROW_SPACE, COLUMNS, COL_SPACE, offset, 15, -15);
	  
	   // and then put the spider on top of it.
	   addChild(_spider);
	  _DNAManager = new MANAGER(DNA_array, MovementSequence, ROWS, COLUMNS);
	  
	  // Attach everything to the surface for movement purposes 
	  _surface.attach_things(_spider, DNA_array);
	  this.addEventListener(MouseEvent.MOUSE_WHEEL, scrollWheelHandler); 
	  this.addEventListener(MouseEvent.MOUSE_DOWN, clickAndHoldHandler);
	  this.addEventListener(MouseEvent.MOUSE_UP, clickUpHandler);
	  this.addEventListener(MouseEvent.MOUSE_MOVE, moveHandler);
	  
	  //BuildBoundingParallelogram();
	  
	  Movement();

	
	
  } // end constructor
  
  /*
  	Method for moving everything when we've clicked and held
  */
    function moveHandler(event:MouseEvent):void {
	  
	var MoveAmmountX;
	var MoveAmmountY;
	
	
	MoveAmmountX = OldClickX - event.stageX;
	MoveAmmountY = OldClickY - event.stageY;
	
	  
	if (clicked == true){
		// Our current position is equal to our old position plus the difference
		this.x = (this.x  - MoveAmmountX);
		this.y = (this.y  - MoveAmmountY);
	}
	// update the values
	OldClickX = event.stageX;
	OldClickY = event.stageY;
	
    trace("clickHandler detected an event of type: " + event.type); 
    trace("the event occurred on: " + event.target.name); 
  }
 
  
  
  /*
  Method for detecting an up mouse click (release of the mouse button)
  */
  function clickUpHandler(event:MouseEvent):void {
	
	trace("clickHandler detected an event of type: " + event.type); 
    trace("the event occurred on: " + event.target.name); 
    
	clicked = false;
  }
  
  
  /*
  Method for detecting a mouse click and hold
  */
 private function clickAndHoldHandler(event:MouseEvent):void {
    trace("clickHandler detected an event of type: " + event.type); 
    trace("the event occurred on: " + event.target.name); 
	var old_clicked = clicked;
	
	if (old_clicked == false){
		clicked = true;
	}
	
	if (old_clicked == true){
		clicked = false;
	}
	
	OldClickX = event.stageX;
	OldClickY = event.stageY;
  }
  
  /*
  Method for resizing on mouse scroll wheeling
  */
  
    private function scrollWheelHandler(event:MouseEvent):void{
	 
	 trace('     event.delta = ' + event.delta + '\n');
	
	 trace('     1+event.delta/10 = ' + 1+event.delta/10 + '\n');

	 var toScale : Number = 1 + (event.delta / 10);
	 trace ('    toScale = ' + toScale + '\n');
	 resize(toScale);
		  
  }
  
  /* 
  Helper method for scrollWheelHandler
  */
  
  private function resize(input : Number){
	  var OldScaleX = this.scaleX;
	  var OldScaleY = this.scaleY;

	  	this.scaleX = input * OldScaleX;
	  	this.scaleY = input * OldScaleY;
  } 
  /*
  Method for debug printing
  */
  private function dtrace(input: String){
	if (debug == true){
		trace(input);
	}
  }

  private function Movement():void
  {
	  // Here is some spider movement stuff.
	
	trace("inside Movement");
	// Walking back and forth along X works well.	

	var oldX = MovementSequence[0][0]; // Current values here
	var oldY = MovementSequence[0][1]; 
	
	// No error checking yet; if our array changes by more than one each element it doesn't make sense
	//
	// Also, I should make a spider pause (same element as last one) function for the future.
	
	for (var x = 0; x<MovementSequence.length; x++){    
			dtrace("   inside Movement : First For loop");
		if((MovementSequence[x][0] == oldX) && (MovementSequence[x][1] == oldY)){
			dtrace("spider reference = " + _spider);
			_spider.stay_still();
			dtrace("Spider Staying Still");
			continue;
		}

	
		// If we are moving in the X direction....
		if (MovementSequence[x][0] != oldX){		
			// Are we moving positive?
			if (MovementSequence[x][0] > oldX){
				dtrace("positive x movement");
				_spider.walk_X(COL_SPACE, plane_incline);
				//_spider.Walk_Bottom_Right();
				oldX = oldX + 1;
				continue;
			}
		
			// Or negative?
			if (MovementSequence[x][0] < oldX){
				dtrace("negative x movement");
				_spider.walk_X(-COL_SPACE, -plane_incline);
				oldX = oldX - 1;
				continue;
			}
		} // end movement X
			
		// If we are moving in the Y direction
		if (MovementSequence[x][1] != oldY){																		
			
			if (HEX == true){
				if (MovementSequence[x][1] > oldY){
					dtrace("    inside Movement : Y-direction");
					_spider.walk_diagonal_up(ROW_SPACE, offset, plane_incline);
					oldY = oldY + 1;
					continue;
				}
				if (MovementSequence[x][1] < oldY){
					_spider.walk_diagonal_down(ROW_SPACE, offset, plane_incline);
					oldY = oldY - 1;
					continue;
				}
			} // end hex y movement
			
			// Moving positive
			if (MovementSequence[x][1] > oldY){
				_spider.walk_Y_down(ROW_SPACE, plane_incline);
				dtrace("positive y movement");
				oldY = oldY + 1;
				continue;
			}
			
			// Moving Negative
			if (MovementSequence[x][1] < oldY){
       			_spider.walk_Y_up(ROW_SPACE, plane_incline);
				dtrace("negative y movement");
				oldY = oldY - 1;
				continue;
			}
			
		} // end Movement X
		

		
	 } // end for movement sequence*/	  
	 _spider.ThrowAway();
  }
  
  
  // This is a function to determine the area of a triange
  public function AreaTriangle(p1 : Point, p2 : Point, p3 : Point) : Number
  { 
	 /* http://mathforum.org/library/drmath/view/54735.html
	 Area of a triangle can be found using the determinant:

     A = abs(1/2 * |x1  y1  1| )
                   |x2  y2  1|
                   |x3  y3  1|
	  */
	  
	  /*
	  A = abs(1/2 * |p1.x p1.y 1|)
	                |p2.x p2.y 1|
					|p3.x p3.y 1|)
					
	  */
	  
	  // http://www.euclideanspace.com/maths/algebra/matrix/functions/determinant/threeD/index.htm
	   // assumes matrix indices start from 0 (0,1 and 2)
   	  
	  
	  var value = p1.x * ((p2.y * 1) - (p3.y * 1)) - p2.x * ((p1.y * 1)- (p3.y * 1)) + p3.x * ((p1.y * 1 ) - (p2.y * 1));	  
	  
	  
	  dtrace("value before dividing = " + value);
	  
	  
	  value = value / 2;
	  
	  if (value < 0){
		value = -value  
	  }
	  
	  
	  return value;
  }
  
  public function Inside_Triangle(question : Point, p1 : Point, p2 : Point, p3 : Point) : Boolean{
	  var area1 : Number, area2 : Number, area3 : Number, startTriangle : Number;
	  
	  area1 = AreaTriangle(question, p1, p2);
	  area2 = AreaTriangle(question, p2, p3);
	  area3 = AreaTriangle(question, p1, p3);
	  
	  startTriangle = AreaTriangle(p1, p2, p3);
	  
	  if (startTriangle == area1 + area2 + area3){
		return true;  
	  }
	  
	  return false;
  }
  
  
  // Declare our function to take two arguments, of type Number
  // We return a variable of type Boolean
  public function Intersect_Correctly (question : Point , p1 : Point, p2 : Point, p3 : Point, p4 : Point) :Boolean{

	  var result : Boolean;

	  // Check the triangle created by the left-most 3 points  
	  result = Inside_Triangle(question, p1, p2, p3);
	  
	  if (result == true){
		return true;  
	  }
	  
	  // Check the trianlge created by the right-most 3 points
	   result = Inside_Triangle(question, p2, p3, p4);
	   if (result == true){
		  return true;  
	   }
	  return false;
  }
  
  

    
  public function GenerateSurface(ROWS, COLUMNS, ROW_SPACE, COL_SPACE, ROTATION){
	  _surface = new SURFACE();
	  	
		var MaxPoint : Point = new Point(5,5);
		var MinPoint : Point = new Point(0,0);
		
	  _surface.set_bounds(MinPoint, MaxPoint);
		
	  // I don't want to rescale the surface depending on how many rows and columns there are right now
	  _surface.scaleX = (ROWS / 6) * (ROW_SPACE / 60);	// Divisors custom fitted to this surface
	  _surface.scaleY = (COLUMNS / 4) * (COL_SPACE / 40);

	  _surface.x = 0; // Magic numbers to make things look OK
	  _surface.y = 50;
	  
	  _surface.rotation = ROTATION;
	  
	  addChild(_surface);	
  }
  
  private function BuildBoundingParallelogram(){

	 	var bounds_obj:Object = _surface.getBounds(this); // Get the bounds of our surface
	  
	  	var minX = bounds_obj.x;
		var maxX = minX+ bounds_obj.width;
		var minY = bounds_obj.y;
		var maxY = minY + bounds_obj.height;
	  
	  // Top left marker
		_DNA = new DNA();
		_DNA.x = minX + 320;
		_DNA.y = minY - 30;
		_DNA.scaleY = .2;
	   	_DNA.scaleX = .2;
		var colorTransform:ColorTransform = _DNA.transform.colorTransform;
		colorTransform.color = 0xFF0000;
		_DNA.transform.colorTransform = colorTransform;
		
		
		if (debug == true){
			addChild(_DNA);
		}
		
		TopLeftPoint = new Point();
		TopLeftPoint.x = _DNA.x;
		TopLeftPoint.y = _DNA.y;
		
		// Bottom left marker
		_DNA = new DNA();
		_DNA.x = minX + 10;
		_DNA.y = maxY - 60;
		_DNA.scaleY = .2;
	   	_DNA.scaleX = .2;
		var colorTransform:ColorTransform = _DNA.transform.colorTransform;
		colorTransform.color = 0xFF0000;
		_DNA.transform.colorTransform = colorTransform;
		
		/*addChild(_DNA);
		// This looks good. 
		trace("BottomLeft absolute cordinates  X = " + _DNA.x);
		trace("BottomRight absolute cordinates Y = " + _DNA.y);
		*/
		
		if (debug == true){
			addChild(_DNA);
		}
		
		BottomLeftPoint = new Point();
		BottomLeftPoint.x = _DNA.x;
		BottomLeftPoint.y = _DNA.y;
		
		// Top right marker
		_DNA = new DNA();
		_DNA.x = maxX - 25;
		_DNA.y = minY - 25;
		_DNA.scaleY = .2;	
	   	_DNA.scaleX = .2;
	    var colorTransform:ColorTransform = _DNA.transform.colorTransform;
		colorTransform.color = 0xFF0000;
		_DNA.transform.colorTransform = colorTransform;
		addChild(_DNA);
		if (debug == true){
			addChild(_DNA);
		}
		
		TopRightPoint = new Point();
		TopRightPoint.x = _DNA.x;
		TopRightPoint.y = _DNA.y;
		
		// Bottom right marker
		_DNA = new DNA();
		_DNA.x = maxX - 300;
		_DNA.y = maxY - 75;
		_DNA.scaleY = .2;
	   	_DNA.scaleX = .2;
		var colorTransform:ColorTransform = _DNA.transform.colorTransform;
		colorTransform.color = 0xFF0000;
		_DNA.transform.colorTransform = colorTransform;
		
		if (debug == true){
			addChild(_DNA);
		}
		
		BottomRightPoint = new Point();
		BottomRightPoint.x = _DNA.x;
		BottomRightPoint.y = _DNA.y;  
  }
  
  public function GenerateRandom(number, incline){

	    var bounds_obj:Object = _surface.getBounds(this); // Get the bounds of our surface
		
		var minX = bounds_obj.x;
		var maxX = minX+ bounds_obj.width;
		var minY = bounds_obj.y;
		var maxY = minY + bounds_obj.height;
		var colorTransform:ColorTransform;						
		var checker = 0;
		
		for (var x = 1; x < number; x++){
			dtrace("\n");
			_DNA = new DNA();
			checker = checker + 1;
			
			// Generate the random placement without our bounding box for our surface
			_DNA.x = Math.ceil(Math.random() * (maxX - minX )) + (minX);
			_DNA.y = Math.ceil(Math.random() * (maxY - minY )) + (minY );
			
			_DNA.scaleY = .2;			// scale it down a bit	
	   		_DNA.scaleX = .65;
			
			var DNA_Point : Point = new Point();
			DNA_Point.x = _DNA.x;
			DNA_Point.y = _DNA.y;
						
			var inside_bounds : Boolean;
			
			// Are we correctly inside our surface, which is inside our bounding box?
			inside_bounds = Intersect_Correctly(DNA_Point, TopLeftPoint, BottomLeftPoint, TopRightPoint, BottomRightPoint);
            dtrace("inside_bounds = " + inside_bounds);
			
			if ( inside_bounds == false){
				dtrace (x + " not added");
				x = x - 1;
			}
			
			if (inside_bounds == true)
			{ 
			    dtrace (x + " added\n");
				addChild(_DNA);
			}
			
			if (checker > 5000){
				dtrace("checker > 5000");
				break;
			}
	}
  }
  
  public function GenerateSquare(xNum, xspace, yNum, ySpace, plane_incline, plane_rotation){
		var NumInRow = xNum; 		// Number of elements per row
    	var NumInColumns = yNum; 	// Number of elements per column
   		var ABS_y = 80;  		// Offset from the top, FLASH counts (positive y = down)
		var ABS_x = 40;
		for(y=0;y<NumInColumns; y++){
			for(x=0;x<NumInRow; x++){			
 	 			_DNA = new DNA();			// Make our new item
   				_DNA.x = 100 + xspace * x + ABS_x;		// set the x
   				_DNA.y = ySpace * y + ABS_y;	// set the y
   				_DNA.scaleY = .2;			// scale it down a bit	
   				_DNA.scaleX = .60;
				_DNA.rotation = plane_rotation;		// get some psuedo-3D stuff going on
				var inside_bounds : Boolean;
			
				var DNA_Point : Point = new Point();
				DNA_Point.x = _DNA.x;	
				DNA_Point.y = _DNA.y;
			
				// Are we correctly inside our surface, which is inside our bounding box?
				dtrace("DNA_Point = " + DNA_Point);
				dtrace("TopLeftPoint = "+TopLeftPoint);
				//inside_bounds = Intersect_Correctly(DNA_Point, TopLeftPoint, BottomLeftPoint, TopRightPoint, BottomRightPoint);
				
				
				//if ((x = 3) && (y = 3)){
					
				//}
				//else {
					addChild(_DNA);				// add it to the map
					DNA_array.push(_DNA);
				//}
			
				
				//addChild(_DNA);	
				
			} // end for y
			if (plane_incline != 0){
		 		ABS_y = ABS_y - plane_incline; 		    // We climb up a bit to get the fake 3D look
			}
			else{
				ABS_y = ABS_y - 2;
			}
   		}// end for x
  } // end GenerateSquare() 
  
  public function GenerateHex(xNum, xspace, yNum, ySpace, offset, plane_incline, plane_rotation)
  {
	    HEX = true; // Set this so our movement method knows what to do
 	  
	    var NumInRow = xNum; 		// Number of elements per row
    	var NumInColumns = yNum; 	// Number of elements per column
   		var ABS_y = 50;  		// Offset from the top, FLASH counts (positive y = down)
		var ABS_x = 50;
		for(y=0;y<NumInColumns; y++){
			for(x=0;x<NumInRow; x++){		
 	 			_DNA = new DNA();			// Make our new item
   				
				if (y % 2 == 0){
					_DNA.x = 100 + xspace * x + ABS_x;		// set the x
				}
				if (y % 2 == 1){ // we need to offset every other row
					_DNA.x = offset + 100 + xspace * x+ ABS_x;
				}
   				_DNA.y = ySpace * y + ABS_y;	// set the y
   				_DNA.scaleY = .2;			// scale it down a bit	
   				_DNA.scaleX = .2;
				_DNA.rotation = plane_rotation;		// get some psuedo-3D stuff going on
				addChild(_DNA);				// add it to the map
				//DNA_array
				DNA_array.push(_DNA);
				//_DNA.CLEAVE();
			} // end for y
		//ABS_y = ABS_y - plane_incline; 		    // We climb up a bit to get the fake 3D look
   		}// end for x
		
  } // end GenerateHex  
 } // end class
 
} // end package